/**
 * $Id: editor_plugin_src.js 201 2007-02-12 15:56:56Z spocke $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2007, Moxiecode Systems AB, All rights reserved.
 */

/* Import theme	specific language pack */
tinyMCE.importPluginLanguagePack('filebrowser');

var TinyMCE_FileBrowserPlugin = {
	
	getInfo : function() {
		return {
			longname : 'File Browser',
			author : 'Joao Pinto',
			authorurl : 'http://jplpinto.com',
			infourl : 'http://jplpinto.com/apis/filemanager/',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},

	getControlHTML : function(cn)	{
		switch (cn) {
			case "filebrowser":
				return tinyMCE.getButtonHTML(cn, 'lang_fileBrowser_desc', '{$pluginurl}/images/filebrowser.gif', 'mceFileBrowser');
		};

		return "";
	},

	/**
	 * Executes	the	search/replace commands.
	 */
	execCommand : function(editor_id, element, command,	user_interface,	value) {
		// Handle commands
		switch (command) {
			case "mceFileBrowser":
				var url = tinyMCE.getLang('lang_fileBrowser_url_dir_files', null);
				TinyMCE_FileBrowserPlugin.fileSearchBrowser(editor_id,url,'all',null);
				return true;
		};

		// Pass to next handler in chain
		return false;
	},

	fileSearchBrowser : function(field_name, url, type, win) {
		var template = new Array();

		template['file']   = '../../plugins/filebrowser/filebrowser.htm'; // Relative to theme
		template['width']  = screen.availWidth;
		if (tinyMCE.isIE) {
			template['height'] = screen.availHeight-40;
		}else {
			template['height'] = screen.availHeight-20;
		}
		template['close_previous'] = 'no';

		template['width']  += tinyMCE.getLang('lang_fileBrowser_delta_width', 0);
		template['height'] += tinyMCE.getLang('lang_fileBrowser_delta_height', 0);
		
		tinyMCE.openWindow(template, {field_name : field_name, editor_id : tinyMCE.getWindowArg('editor_id'), inline : "yes", win : win, type : type, url : url, resizable : "yes"});
	}
};

tinyMCE.addPlugin("filebrowser", TinyMCE_FileBrowserPlugin);