/**
 * $Id: editor_plugin_src.js 201 2007-02-12 15:56:56Z spocke $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2007, Moxiecode Systems AB, All rights reserved.
 */

/* Import theme	specific language pack */
tinyMCE.importPluginLanguagePack('filemanager');

var TinyMCE_FileManagerPlugin = {
	
	getInfo : function() {
		return {
			longname : 'File Manager',
			author : 'Joao Pinto',
			authorurl : 'http://jplpinto.com',
			infourl : 'http://jplpinto.com/apis/filemanager/',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},

	getControlHTML : function(cn)	{
		switch (cn) {
			case "filemanager":
				return tinyMCE.getButtonHTML(cn, 'lang_fileManager_desc', '{$pluginurl}/images/filemanager.gif', 'mceFileManager');
		};

		return "";
	},

	/**
	 * Executes	the	search/replace commands.
	 */
	execCommand : function(editor_id, element, command,	user_interface,	value) {
		// Handle commands
		switch (command) {
			case "mceFileManager":
				var url = tinyMCE.getLang('lang_fileManager_url_dir_files', null);
				TinyMCE_FileManagerPlugin.fileSearchBrowser(editor_id,url,'all',null);
				return true;
		};

		// Pass to next handler in chain
		return false;
	},

	fileSearchBrowser : function(field_name, url, type, win) {
		var template = new Array();

		var base_url = tinyMCE.baseURL;
		var protocol = '';
		if(base_url) {
			if(base_url.indexOf('http://') == 0) {
				base_url =  base_url.substring(7,base_url.length);
				protocol = 'http://';
			}else if(base_url.indexOf('https://') == 0) {
				base_url.substring(8,base_url.length);
				protocol = 'https://';
			}
		}

		template['file']   = '../../plugins/filemanager/src/interfacelevel/filemanager.php?filemanager_prefix_path='+base_url+'/plugins&filemanager_prefix_http_protocol='+protocol+'&filemanager_type='+type;
		template['width']  = screen.availWidth;
		if (tinyMCE.isIE) {
			template['height'] = screen.availHeight-40;
		}else {
			template['height'] = screen.availHeight-20;
		}
		template['close_previous'] = 'no';

		template['width']  += tinyMCE.getLang('lang_fileManager_delta_width', 0);
		template['height'] += tinyMCE.getLang('lang_fileManager_delta_height', 0);

		tinyMCE.openWindow(template, {field_name : field_name, editor_id : tinyMCE.getWindowArg('editor_id'), inline : "yes", win : win, type : type, url : url, resizable : "yes"});
	}
};

tinyMCE.addPlugin("filemanager", TinyMCE_FileManagerPlugin);