function init() {
	var editor_id = tinyMCE.getWindowArg('editor_id');
	var inst = tinyMCE.getInstanceById(editor_id);
	var elm = inst.getFocusElement();

	if(elm && elm.nodeName.toUpperCase() == 'SELECT') {
		var formObj = document.forms[0];
		formObj.insert.value = 'Modify';
	
		var attrs = '';
		for(var i = 0; i < elm.attributes.length; ++i) 
			if(elm.attributes[i].name != 'id' && elm.attributes[i].name != 'name' && elm.attributes[i].name != 'size' && elm.attributes[i].name != 'style' && elm.attributes[i].name != 'multiple')
				attrs += ' '+elm.attributes[i].name+'="'+elm.attributes[i].value+'"';
	
		formObj.formselect_id.value = elm.getAttribute('id');
		formObj.formselect_name.value = elm.getAttribute('name');
		formObj.formselect_size.value = elm.getAttribute('size');
		formObj.formselect_attributes.value = attrs;
		formObj.formselect_style.value = elm.getAttribute('style');
		formObj.formselect_options.innerHTML = elm.innerHTML;
		
		if(elm.getAttribute('multiple') != null)
			formObj.formselect_type.options[1].selected = true;
	}
};

function insertAction() {
	var formObj = document.forms[0];
	if(formCheck(formObj)) {
		var editor_id = tinyMCE.getWindowArg('editor_id');
		var inst = tinyMCE.getInstanceById(editor_id);
	
		var id = formObj.formselect_id.value;
		var name = formObj.formselect_name.value;
		var type = formObj.formselect_type;
		var type_value = type ? type.options[type.selectedIndex].value : '';
		var size = formObj.formselect_size.value;
		var attributes = formObj.formselect_attributes.value;
		var style = formObj.formselect_style.value;
		var select_options = formObj.formselect_options.innerHTML;
	
		var html = '&nbsp;<select';
		if (id && id != "")
			html += ' id="'+id+'"';
		if (name && name != "")
			html += ' name="'+name+'"';
		if (type_value && type_value != "")
			html += ' '+type_value;
		if (size && size != "")
			html += ' size="'+size+'"';
		if (attributes && attributes != "")
			html += ' '+attributes;
		if (style && style != "")
			html += ' style="'+style.replace(/"/g,'')+'"';
		html += ' >'+select_options+'</select>&nbsp;<br/>';
	
		tinyMCEPopup.execCommand("mceInsertContent", false, html);
		tinyMCE._setEventsEnabled(inst.getBody(), false);
		tinyMCEPopup.close();
	}
};

function cancelAction() {
	tinyMCEPopup.close();
};

function addOption() {
	var formObj = document.forms[0];
	var text = formObj.formselect_option_text.value;
	var value = formObj.formselect_option_value.value;
	var attributes = formObj.formselect_option_attributes.value;
	var selected = formObj.formselect_option_selected.checked ? 'selected' : '';
	
	var html = '<option';
	if(value && value != '')
		html += ' value="'+value+'"';
	if(attributes && attributes != '')
		html += ' '+attributes;
	if(selected && selected != '')
		html += ' '+selected;
	if(text)
		html += '>'+text;
	html += '</option>';

	formObj.formselect_option_text.value = '';
	formObj.formselect_option_value.value = '';
	formObj.formselect_option_attributes.value = '';
	formObj.formselect_option_selected.checked = false;

	var innerHTML = formObj.formselect_options.innerHTML;
	formObj.formselect_options.innerHTML = innerHTML + html;
};

function updateOption() {
	var formObj = document.forms[0];
	var text = formObj.formselect_option_text.value;
	var value = formObj.formselect_option_value.value;
	var attributes = formObj.formselect_option_attributes.value;
	var selected = formObj.formselect_option_selected.checked ? 'true' : 'false';
	
	var index = formObj.formselect_options.selectedIndex;
	if(index >= 0) {
		var option = formObj.formselect_options.options[index];
		if(option) {
			option.setAttribute('value',value);
			option.setAttribute('selected',selected);
			option.innerHTML = text;
			updateAttributes(option,attributes);
		}
	}
};

function deleteOption() {
	var formObj = document.forms[0];
	var index = formObj.formselect_options.selectedIndex;
	if(index >= 0)
		formObj.formselect_options.remove(index);
};

function reloadOptionData() {
	var formObj = document.forms[0];
	var index = formObj.formselect_options.selectedIndex;
	if(index >= 0) {
		var option = formObj.formselect_options.options[index];
		var option_attr = '';
		for(var i = 0; i < option.attributes.length; ++i) 
			if(option.attributes[i].name != 'value' && option.attributes[i].name != 'selected')
				option_attr += ' '+option.attributes[i].name+'="'+option.attributes[i].value+'"';
				
		formObj.formselect_option_text.value = option.innerHTML;
		formObj.formselect_option_value.value = option.value;
		formObj.formselect_option_attributes.value = option_attr;
		formObj.formselect_option_selected.checked = option.getAttribute('selected') != null ? true : false;
	}
};
